package com.inca.npbusi.saset.bms_sa_reconciliation;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.CommandBase;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CDefaultProgress;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CToolbar;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.MdeFrame;
import com.inca.np.gui.ste.Steframe;
import com.inca.np.gui.tbar.TButton;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.dataimport.ImpHelper;
import com.inca.npclient.system.Clientframe;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.HeadlessException;
import java.awt.event.ActionListener;
import java.io.FileInputStream;
import java.util.Vector;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

public class Bms_sa_reconciliation_ste extends CSteModelAp {
  String entryid = "";
  
  String entryname = "";
  
  private int errorflag;
  
  public String getEntryid() {
    return this.entryid;
  }
  
  public void setEntryid(String entryid) {
    this.entryid = entryid;
  }
  
  public String getEntryname() {
    return this.entryname;
  }
  
  public void setEntryname(String entryname) {
    this.entryname = entryname;
  }
  
  public Bms_sa_reconciliation_ste(CFrame frame) throws HeadlessException {
    super(frame, "对账领用单");
    this.errorflag = 0;
    setEntryid(ClientUserManager.getCurrentUser().getEntryid());
    setEntryname(ClientUserManager.getCurrentUser().getEntryname());
  }
  
  public String getTablename() {
    return "BMS_SA_RECONCILIATION_V";
  }
  
  public String getSaveCommandString() {
    return "com.inca.npbusi.saset.bms_sa_reconciliation.Bms_sa_reconciliation_ste.保存对账领用单";
  }
  
  protected int on_new(int row) {
    String entryid = getEntryid();
    String receivemanid = ClientUserManager.getCurrentUser().getUserid();
    setItemValue(row, "entryid", entryid);
    setItemValue(row, "userid", receivemanid);
    setItemValue(row, "rdate", NpbusiDBHelper.getSysdate());
    setItemValue(row, "HTOTAL", "0");
    setItemValue(row, "RTOTAL", "0");
    return super.on_new(row);
  }
  
  protected JPanel createSecondtoolbar() {
    JPanel jp = new JPanel(new BorderLayout());
    CToolbar c = new CToolbar();
    c.setLayout(new BorderLayout());
    jp.add((Component)c);
    createPanel(jp, "South");
    return jp;
  }
  
  private void createPanel(JPanel jp, String postion) {
    CToolbar c = (CToolbar)jp.getComponent(0);
    JPanel tmp = new JPanel(new FlowLayout(0));
    createTButton(tmp, "快速查询医院使用单", "快速查询医院使用单", "快速查询医院使用单", 79, (ActionListener)this);
    c.add(tmp, "South");
    createTButton(tmp, "快速查询销售单", "快速查询销售单", "快速查询销售单", 80, (ActionListener)this);
    c.add(tmp, "South");
  }
  
  private void createTButton(JPanel jpanel, String title, String tips, String command, int keychar, ActionListener listener) {
    TButton item = null;
    item = new TButton(" " + title + " ");
    item.setToolTipText(tips);
    item.setActionCommand(command);
    item.addActionListener(listener);
    item.setMnemonic(keychar);
    item.setFocusable(false);
    item.setForeground(Color.blue);
    item.setFont(new Font("宋体", 0, 17));
    jpanel.add((Component)item);
    jpanel.setBackground(jpanel.getComponent(0).getBackground());
  }
  
  protected int on_actionPerformed(String command) {
    if (command.equals("快速查询医院使用单")) {
      String rid = getItemValue(getRow(), "RID");
      ((Steframe)Clientframe.getClientframe().runOp("3021", false)).getCreatedStemodel().doRetrieve("1=1 AND RID =" + rid + " ");
    } 
    if (command.equals("快速查询销售单")) {
      String salesid = getItemValue(getRow(), "SALESID");
      MdeFrame frm = (MdeFrame)Clientframe.getClientframe().runOp("1070", false);
      CMdeModelAp mde = (CMdeModelAp)frm.getCreatedMdemodel();
      mde.setUsequerythread(false);
      mde.getMasterModel().doRetrieve("SALESID in (" + salesid + ")");
    } 
    if (command.equals("切换独立单元")) {
      if (getModifiedDbmodel().getRowCount() > 0) {
        infoMessage("提示", "有尚未保存的数据，请先作保存！");
        return -1;
      } 
      if (Entrychose.setUserEntryInfo((Frame)this.frame)) {
        setEntryid(ClientUserManager.getCurrentUser().getEntryid());
        setEntryname(ClientUserManager.getCurrentUser().getEntryname());
      } 
      doRetrieve("entryid = -1");
      return 0;
    } 
    if (command.equals("医院使用单导入")) {
      String approvetime = getItemValue(getRow(), "APPROVETIME");
      if (approvetime != null && !"".equals(approvetime)) {
        infoMessage("提示", "对账领用单已确定！");
        return -1;
      } 
      if (getRow() == -1) {
        infoMessage("提示", "请选择对账单进行导入！");
        return -1;
      } 
      String rid = getItemValue(getRow(), "rid");
      if (rid == null || "".equals(rid)) {
        infoMessage("提示", "请选择对账单进行导入！");
        return -1;
      } 
      doImpAction();
      doRequery();
      return 0;
    } 
    if (command.equals("模版下载"))
      excelDownload(); 
    if (command.equals("确定")) {
      if (!"1".equals(getApvalue("确定"))) {
        infoMessage("提示", "没有权限");
        return -1;
      } 
      String approvetime = getItemValue(getRow(), "APPROVETIME");
      if (approvetime != null && !"".equals(approvetime)) {
        infoMessage("提示", "对账领用单已确定！");
        return -1;
      } 
      String rid = getItemValue(getRow(), "RID");
      String sql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + " ";
      RemotesqlHelper rh = new RemotesqlHelper();
      DBTableModel model = null;
      int val = 0;
      try {
        model = rh.doSelect(sql, 0, 200);
        if (model == null || model.getRowCount() <= 0) {
          infoMessage("提示", "医院使用单对码单没有数据，无需确定！");
          return -1;
        } 
        Integer allcount = Integer.valueOf(model.getRowCount());
        String ppSql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + "  and USESTATUS = 2 ";
        model = rh.doSelect(ppSql, 0, 200);
        Integer auditCount = Integer.valueOf(model.getRowCount());
        if (allcount != auditCount) {
          int wppCount = allcount.intValue() - auditCount.intValue();
          if (allcount.intValue() == wppCount) {
            infoMessage("提示", "医院使用单未对码，不能确定！");
            return -1;
          } 
          if (JOptionPane.showConfirmDialog(null, "医院使用单有" + wppCount + "条数据未匹配，是否确定通过?", "确定", 0) != 0)
            return -1; 
        } 
        String shSql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + "  and USESTATUS = 2  ";
        model = rh.doSelect(shSql, 0, 200);
        Integer shallcount = Integer.valueOf(model.getRowCount());
        String jeSql = "select * from HUSEMV_ORDER_DTL_V where rid =" + rid + "  and USESTATUS = 2  and HTOTAL <> ETOTAL ";
        model = rh.doSelect(jeSql, 0, 200);
        Integer jecount = Integer.valueOf(model.getRowCount());
        if (jecount.intValue() <= 0) {
          val = 0;
        } else if (shallcount == jecount) {
          val = 1;
        } else {
          val = 2;
        } 
      } catch (Exception e) {
        e.printStackTrace();
      } 
      String isDzd = "N";
      if (val > 0) {
        if (val == 1 && JOptionPane.showConfirmDialog(null, "金额不符，是否直接生成订单?", "确定", 0) != 0)
          return -1; 
        if (val == 2 && JOptionPane.showConfirmDialog(null, "金额不符，是否直接生成订单? ", "确定", 0) != 0)
          return -1; 
      } 
      auditBmsSaReconciliation(rid, isDzd);
      return 0;
    } 
    return super.on_actionPerformed(command);
  }
  
  private void excelDownload() {
    String[] array = { 
        "备货备注（移库单号）", "产品编码", "通用名", "规格", "单位", "数量", "单价", "金额", "批号", "生产日期", 
        "有效期", "使用日期", "生产企业名称", "注册证号" };
    String s = "医院使用单导入模版";
    try {
      ImpHelper.createExcel(array, s);
      infoMessage("提示", "EXCEL模板生成完成，存放路径：C:/DatabaseExcel/");
    } catch (Exception ex2) {
      Exception ex = ex2;
      ex2.printStackTrace();
      errorMessage("错误", "生成EXCEL模板失败：" + ex.getMessage());
    } 
  }
  
  private void auditBmsSaReconciliation(String rid, String isDzd) {
    String hid = getItemValue(getRow(), "HID");
    String storageid = getItemValue(getRow(), "storageid");
    String customname = getItemValue(getRow(), "customname");
    ClientRequest req = new ClientRequest();
    req.addCommand((CommandBase)new StringCommand("husemv_order_dtl.确定"));
    req.addCommand((CommandBase)new StringCommand(rid));
    req.addCommand((CommandBase)new StringCommand(hid));
    req.addCommand((CommandBase)new StringCommand(storageid));
    req.addCommand((CommandBase)new StringCommand(customname));
    req.addCommand((CommandBase)new StringCommand(isDzd));
    ServerResponse resp = null;
    try {
      resp = SendHelper.sendRequest(req);
      String sercmd = ((StringCommand)resp.commandAt(0)).getString();
      if (sercmd.startsWith("+OK")) {
        infoMessage("提示", "确定成功!");
        doRequery();
      } else {
        infoMessage("提示", "确定失败，原因:" + sercmd);
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  static DBTableModel createConfirmParamdbmodel() {
    Vector<DBColumnDisplayInfo> cols = new Vector<DBColumnDisplayInfo>();
    DBColumnDisplayInfo col = new DBColumnDisplayInfo("salesid", "number");
    cols.add(col);
    col = new DBColumnDisplayInfo("message", "varchar");
    cols.add(col);
    col = new DBColumnDisplayInfo("autofix", "varchar");
    cols.add(col);
    col = new DBColumnDisplayInfo("autokeep", "varchar");
    cols.add(col);
    col = new DBColumnDisplayInfo("usestatus", "number");
    cols.add(col);
    col = new DBColumnDisplayInfo("confirmaname", "varchar");
    cols.add(col);
    col = new DBColumnDisplayInfo("confirmdate", "date");
    cols.add(col);
    col = new DBColumnDisplayInfo("confirmanid", "number");
    cols.add(col);
    col = new DBColumnDisplayInfo("approveflag", "number");
    cols.add(col);
    col = new DBColumnDisplayInfo("allowfix", "number");
    cols.add(col);
    col = new DBColumnDisplayInfo("autofixraise", "number");
    cols.add(col);
    col = new DBColumnDisplayInfo("storageid", "number");
    cols.add(col);
    return new DBTableModel(cols);
  }
  
  private void doImpAction() {
    JFileChooser fDialog = new JFileChooser();
    int result = fDialog.showOpenDialog((Component)this.frame);
    if (result == 0) {
      String str4 = fDialog.getSelectedFile().getPath();
      int tmp1 = str4.lastIndexOf(".");
      String tmp2 = str4.substring(tmp1 + 1);
      if (!"xls".equals(tmp2)) {
        infoMessage("提示", "选中的文件不是.xls类型，不能导入！");
        return;
      } 
      String name = fDialog.getSelectedFile().getName();
      try {
        CDefaultProgress progress = new CDefaultProgress((Frame)this.frame);
        ServerThread thread = new ServerThread(this, progress, str4, name);
        thread.start();
        progress.show();
      } catch (Exception e) {
        e.printStackTrace();
      } 
    } 
  }
  
  private int insertModel(DBTableModel xlsModel) throws Exception {
    ClientRequest req = new ClientRequest();
    DataCommand cmd = new DataCommand();
    cmd.setDbmodel(xlsModel);
    String rid = getItemValue(getRow(), "rid");
    String hid = getItemValue(getRow(), "hid");
    String storageid = getItemValue(getRow(), "storageid");
    req.addCommand((CommandBase)new StringCommand("husemv_order_dtl.使用单导入"));
    req.addCommand((CommandBase)cmd);
    req.addCommand((CommandBase)new StringCommand(rid));
    req.addCommand((CommandBase)new StringCommand(hid));
    req.addCommand((CommandBase)new StringCommand(storageid));
    ServerResponse resp = null;
    resp = SendHelper.sendRequest(req);
    String sercmd = ((StringCommand)resp.commandAt(0)).getString();
    if (!sercmd.startsWith("+OK"))
      throw new Exception(sercmd); 
    return Integer.parseInt(((StringCommand)resp.commandAt(1))
        .getString());
  }
  
  static Vector<DBColumnDisplayInfo> createTmpDBModel() {
    Vector<DBColumnDisplayInfo> infos = new Vector<DBColumnDisplayInfo>();
    DBColumnDisplayInfo info = null;
    info = new DBColumnDisplayInfo("HMOVEID", "varchar", "HMOVEID");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSCODE", "varchar", "HGOODSCODE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSNAME", "varchar", "HGOODSNAME");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSTYPE", "varchar", "HGOODSTYPE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSUSEUNIT", "varchar", "HGOODSUSEUNIT");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSQTY", "varchar", "HGOODSQTY");
    infos.add(info);
    info = new DBColumnDisplayInfo("HUNITPRICE", "varchar", "HUNITPRICE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HAMOUNT", "varchar", "HAMOUNT");
    infos.add(info);
    info = new DBColumnDisplayInfo("HLOTNO", "varchar", "HLOTNO");
    infos.add(info);
    info = new DBColumnDisplayInfo("HPRODDATE", "varchar", "HPRODDATE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HINVALIDDATE", "varchar", "HINVALIDDATE");
    infos.add(info);
    info = new DBColumnDisplayInfo("USEDATE", "varchar", "USEDATE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HFACTORYNAME", "varchar", "HFACTORYNAME");
    infos.add(info);
    info = new DBColumnDisplayInfo("HREGISTDOCNO", "varchar", "HREGISTDOCNO");
    infos.add(info);
    info = new DBColumnDisplayInfo("rows", "varchar", "rows");
    infos.add(info);
    return infos;
  }
  
  private DBTableModel readXls(String path) throws Exception {
    this.errorflag = 0;
    DBTableModel xlsModel = null;
    try {
      HSSFWorkbook workbook = new HSSFWorkbook(new FileInputStream(path));
      HSSFSheet sheet = workbook.getSheetAt(0);
      int rows = sheet.getPhysicalNumberOfRows();
      Vector<DBColumnDisplayInfo> infos = createDBModel();
      xlsModel = new DBTableModel(infos);
      for (int r = 1; r < rows; r++) {
        String value = "";
        HSSFRow row = sheet.getRow(r);
        if (row != null)
          for (short c = 0; c < 42; c = (short)(c + 1)) {
            HSSFCell cell = row.getCell(c);
            if (cell != null)
              switch (cell.getCellType()) {
                case 2:
                  System.out.println("CELL_TYPE_FORMULA");
                  break;
                case 0:
                  value = "";
                  if (c == 6 || c == 7) {
                    value = String.valueOf(value) + (float)cell.getNumericCellValue();
                    break;
                  } 
                  value = String.valueOf(value) + (long)cell.getNumericCellValue();
                  break;
                case 1:
                  value = cell.getStringCellValue();
                  break;
                default:
                  value = "";
                  System.out.println("default");
                  break;
              }  
            xlsModel.appendRow();
            if (c == 0)
              xlsModel.setItemValue(r - 1, "HMOVEID", value); 
            if (c == 1)
              xlsModel.setItemValue(r - 1, "HGOODSCODE", value); 
            if (c == 2)
              xlsModel.setItemValue(r - 1, "HGOODSNAME", value); 
            if (c == 3)
              xlsModel.setItemValue(r - 1, "HGOODSTYPE", value); 
            if (c == 4)
              xlsModel.setItemValue(r - 1, "HGOODSUSEUNIT", value); 
            if (c == 5)
              xlsModel.setItemValue(r - 1, "HGOODSQTY", value); 
            if (c == 6)
              xlsModel.setItemValue(r - 1, "HUNITPRICE", value); 
            if (c == 7)
              xlsModel.setItemValue(r - 1, "HAMOUNT", value); 
            if (c == 8)
              xlsModel.setItemValue(r - 1, "HLOTNO", value); 
            if (c == 9)
              xlsModel.setItemValue(r - 1, "HPRODDATE", value); 
            if (c == 10)
              xlsModel.setItemValue(r - 1, "HINVALIDDATE", value); 
            if (c == 11)
              xlsModel.setItemValue(r - 1, "USEDATE", value); 
            if (c == 12)
              xlsModel.setItemValue(r - 1, "HFACTORYNAME", value); 
            if (c == 13)
              xlsModel.setItemValue(r - 1, "HREGISTDOCNO", value); 
            if (c == 14)
              xlsModel.setItemValue(r - 1, "rows", (new StringBuilder(String.valueOf(rows))).toString()); 
          }  
      } 
      xlsModel.fireTableDataChanged();
      return xlsModel;
    } catch (ArrayIndexOutOfBoundsException e) {
      this.errorflag = 2;
      e.printStackTrace();
      throw new Exception("-Error  导入文件不符合格式规范，导致导入错误！");
    } catch (Exception e) {
      this.errorflag = 2;
      e.printStackTrace();
      throw e;
    } 
  }
  
  static Vector<DBColumnDisplayInfo> createDBModel() {
    Vector<DBColumnDisplayInfo> infos = new Vector<DBColumnDisplayInfo>();
    DBColumnDisplayInfo info = null;
    info = new DBColumnDisplayInfo("HMOVEID", "varchar", "HMOVEID");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSCODE", "varchar", "HGOODSCODE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSNAME", "varchar", "HGOODSNAME");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSTYPE", "varchar", "HGOODSTYPE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSUSEUNIT", "varchar", "HGOODSUSEUNIT");
    infos.add(info);
    info = new DBColumnDisplayInfo("HGOODSQTY", "varchar", "HGOODSQTY");
    infos.add(info);
    info = new DBColumnDisplayInfo("HUNITPRICE", "varchar", "HUNITPRICE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HAMOUNT", "varchar", "HAMOUNT");
    infos.add(info);
    info = new DBColumnDisplayInfo("HLOTNO", "varchar", "HLOTNO");
    infos.add(info);
    info = new DBColumnDisplayInfo("HPRODDATE", "varchar", "HPRODDATE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HINVALIDDATE", "varchar", "HINVALIDDATE");
    infos.add(info);
    info = new DBColumnDisplayInfo("USEDATE", "varchar", "USEDATE");
    infos.add(info);
    info = new DBColumnDisplayInfo("HFACTORYNAME", "varchar", "HFACTORYNAME");
    infos.add(info);
    info = new DBColumnDisplayInfo("HREGISTDOCNO", "varchar", "HREGISTDOCNO");
    infos.add(info);
    info = new DBColumnDisplayInfo("rows", "varchar", "rows");
    infos.add(info);
    return infos;
  }
  
  protected String getEditablecolumns(int row) {
    String approvetime = getItemValue(row, "APPROVETIME");
    if (approvetime != null && !"".equals(approvetime))
      return "remark"; 
    String qtytotal = getItemValue(row, "qtytotal");
    if (qtytotal != null && !"".equals(qtytotal)) {
      Integer total = Integer.valueOf(qtytotal);
      if (total.intValue() > 0)
        return "remark"; 
    } 
    return super.getEditablecolumns(row);
  }
  
  protected int on_beforedel(int row) {
    String approvetime = getItemValue(getRow(), "APPROVETIME");
    String rid = getItemValue(getRow(), "rid");
    if (approvetime != null && !"".equals(approvetime)) {
      infoMessage("提示", "对账领用单已确定！");
      return -1;
    } 
    int on_beforedel = super.on_beforedel(row);
    return on_beforedel;
  }
  
  public String getHovOtherWheres(int row, String colname) {
    return super.getHovOtherWheres(row, colname);
  }
  
  protected String getOtherWheres() {
    String entryid = getEntryid();
    return " entryid = " + entryid;
  }
  
  public int on_beforesave() {
    return super.on_beforesave();
  }
  
  protected int on_checkrow(int row, DBTableModel model) {
    return super.on_checkrow(row, model);
  }
}
